#!/bin/sh
#
# MBCD v0.2
#
# make customised multiboot-cd
# (c) 2004 by Stephan Walter <stephan.walter@epfl.ch>
# Licensed under the GNU General Public License (GPL)
# http://cowww.epfl.ch/~swalter/

VERSION=0.2

# WARNING: This is a excellent example of horrible programming.
#          Don't read it as it'll damage your brain.
#############################################################################

function initialisation()
{
if which Xdialog >/dev/null
then
	DIALOG=Xdialog
	FWINDOWSIZE="0 0"
elif which xdialog >/dev/null
then
	DIALOG=xdialog
	FWINDOWSIZE="0 0"
elif which dialog >/dev/null
then
	DIALOG=dialog
	FWINDOWSIZE="13 60"
else
	echo "dialog or Xdialog is missing."
	return 1
fi

if which tempfile >/dev/null
then
	TEMP=`tempfile`
	CHOICE=`tempfile`
else
	TEMP=./tmp1
	CHOICE=./tmp3
fi
}

#############################################################################

function getkmap()
{
# Get a list of all keymaps in /usr/share/keymaps/i386
find /usr/share/keymaps/i386 -name "*.kmap*" | xargs -l1 basename | sort | sed "s/.kmap.*$//" | awk '{ printf("%s \"\" ", $1, $1) }' > $TEMP

# Ask user which one she wants
xargs < $TEMP 2>$CHOICE $DIALOG --nocancel --title "Keyboard Layout" --default-item us --menu "Please choose keyboard layout that will be used at boot time.\n\nIf you plan to use your CD on PCs with different keyboards, it may be best to use the standard \"us\"." 0 0 0

# Convert it to LILO-keytab-format
./keytab-lilo `cat $CHOICE` > master/isolinux/keymap
}

#############################################################################


function addimage()
{
$DIALOG --nocancel --title "Select image type" --menu "Please select the type of the image file you want to add to your CD:" 0 0 0 floppy "Floppy image (1.44M or 2.88M)" knoppix "Knoppix or derivative (ISO)" bin "Kernel-binary image (e.g. memtest86)" win "Windows XP Recovery Console" end "No more images to add - master CD" quit "Cancel program" 2> $CHOICE

case `cat $CHOICE` in
  floppy)
  	$DIALOG --nocancel --title "Select floppy image" --fselect `pwd` $FWINDOWSIZE 2> $CHOICE
	IMGFILE=`cat $CHOICE`
	SIZE=`du -b $IMGFILE | awk "{ print \\$1 }"`
	case $SIZE in
	  1474560 | 2949120)
	  	NAMETEMPLATE=`basename $IMGFILE | awk "{ print substr(\\$1,1,8) }"`
	  	$DIALOG --nocancel --title "Adding Image..." --inputbox \
		  "Floppy image size is $SIZE bytes, adding it to the CD.\n\nEnter a keyword for it: (max. 8 characters)"\
		  0 0 $NAMETEMPLATE 2>$CHOICE
		KEYWORD=`cat $CHOICE | awk "{ print substr(\\$1,1,8) }"`
		cp $IMGFILE master/isolinux/$KEYWORD.img
		echo $KEYWORD >> master/isolinux/list
		echo "LABEL $KEYWORD" >> master/isolinux/isolinux.cfg
		echo "  KERNEL memdisk" >> master/isolinux/isolinux.cfg
		echo "  APPEND initrd=$KEYWORD.img" >> master/isolinux/isolinux.cfg
	  	;;
	  *)
	  	$DIALOG --title "Error" --msgbox \
		  "Floppy image must be exactly 1474560 or 2949120 bytes in size." 0 0
		return 0 ;;
	esac
	;;
  knoppix)
	$DIALOG --nocancel --title "Knoppix" --inputbox "Where is the Knoppix CD mounted:" 0 0 /cdrom 2>$CHOICE
	KNOPPIX=`cat $CHOICE`
	if [ -f $KNOPPIX/KNOPPIX/KNOPPIX ]
	then
		$DIALOG --nocancel --title "Adding Image..." --inputbox \
		"Enter a keyword for this boot image (max 8 characters)" 0 0 knoppix 2>$CHOICE
		KEYWORD=`cat $CHOICE | awk "{ print substr(\\$1,1,8) }"`
		cp $KNOPPIX/KNOPPIX/boot.img master/isolinux/$KEYWORD.img
		echo $KEYWORD >> master/isolinux/list
		echo "LABEL $KEYWORD" >> master/isolinux/isolinux.cfg
		echo "  KERNEL memdisk" >> master/isolinux/isolinux.cfg
		echo "  APPEND initrd=$KEYWORD.img" >> master/isolinux/isolinux.cfg
		mkdir master/KNOPPIX
		cp $KNOPPIX/KNOPPIX/KNOPPIX master/KNOPPIX
	else
		$DIALOG --title "Error" --msgbox "No Knoppix files found in this directory." 0 0
		return 0
	fi
	;;
  bin)
  	$DIALOG --nocancel --title "Select kernel image" --fselect `pwd` $FWINDOWSIZE 2> $CHOICE
	IMGFILE=`cat $CHOICE`
	NAMETEMPLATE=`basename $IMGFILE | awk "{ print substr(\\$1,1,6) }"`
	$DIALOG --nocancel --title "Adding Image..." --inputbox "Adding kernel image it to the CD.\n\nEnter a keyword for it: (max. 8 characters)" 0 0 $NAMETEMPLATE 2>$CHOICE
	KEYWORD=`cat $CHOICE | awk "{ print substr(\\$1,1,8) }"`
	cp $IMGFILE master/isolinux/$KEYWORD.krn
	echo $KEYWORD >> master/isolinux/list
	echo "LABEL $KEYWORD" >> master/isolinux/isolinux.cfg
	echo "  KERNEL $KEYWORD.krn" >> master/isolinux/isolinux.cfg
	;;
  win)
	$DIALOG --nocancel --title "Windows XP Recovery Console" --inputbox "NOTE: This is only tested with Win XP Pro German\nWhere is the Win XP CD mounted:" 0 0 /cdrom 2>$CHOICE
	WINXP=`cat $CHOICE`
	if [ -d $WINXP/I386 ]
	then
		mkdir master/I386
		cp w2ksect.bin master/isolinux
		echo "winxp" >> master/isolinux/list
		echo "LABEL winxp" >> master/isolinux/isolinux.cfg
		echo "  KERNEL w2ksect.bin" >> master/isolinux/isolinux.cfg
		for FILE in `cat wxppro.list`
		do
			cp --no-preserve=mode -r $WINXP/$FILE master/$FILE
		done
	else
		$DIALOG --title "Error" --msgbox "Windows XP files not found!" 0 0
	fi
	;;
  end)
	return 1 ;;
  quit)
  	exit 1 ;;
esac
return 0
}

#############################################################################

function makesplash()
{
cat > master/isolinux/splash <<EOF


+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                  MULTIBOOTCD
+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++


EOF
echo "                               MBCD version: $VERSION" >> master/isolinux/splash
cat >> master/isolinux/splash <<EOF

                            (c) 2004 Stephan Walter

              Licensed under the GNU General Public Licence (GPL)

                        http://cowww.epfl.ch/~swalter/



                PRESS [F2] FOR A LIST OF IMAGES TO BOOT FROM

EOF
echo "                          CD build date: `date +%Y-%m-%d`" >> master/isolinux/splash
echo >> master/isolinux/splash
}

#############################################################################

function makeiso()
{
ISOFILE=mbcd-`date +%Y-%m-%d`.iso

mkisofs -pad -r -hide-rr-moved -N -o $ISOFILE \
	-P "MBCD by Stephan Walter" -p "http://cowww.epfl.ch/~swalter/mbcd" -V "MBCD" \
	-b isolinux/isolinux.bin -c isolinux/boot.cat -no-emul-boot -boot-load-size 4 \
	-boot-info-table master

ISOSIZE=`du --apparent-size -h $ISOFILE | awk "{ print \\$1 }"`

$DIALOG --title "CD image built succesfully" --msgbox "The image of your personal Multiboot-CD has been built.\n\nFilename: $ISOFILE\nSize: ${ISOSIZE}B\n\nBurn, baby, burn ;-)" 0 0
}

#############################################################################
#############################################################################

rm -fr master/*
mkdir master/isolinux
cp isolinux.bin master/isolinux
cp memdisk master/isolinux

if ! initialisation
then
exit 1
fi

getkmap

cp list.template master/isolinux/list
cp isolinux.cfg.template master/isolinux/isolinux.cfg

while addimage
do
	 #nothing
	 :
done

makesplash
echo >> master/isolinux/list

makeiso

rm $CHOICE
rm $TEMP
rm -fr master/*
